<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>HttpService xref</title>
<link type="text/css" rel="stylesheet" href="../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../apidocs/org/apache/http/protocol/HttpService.html">View Javadoc</a></div><pre>

<a class="jxr_linenumber" name="1" href="#1">1</a>   <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="2" href="#2">2</a>   <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="3" href="#3">3</a>   <em class="jxr_comment"> * Licensed to the Apache Software Foundation (ASF) under one</em>
<a class="jxr_linenumber" name="4" href="#4">4</a>   <em class="jxr_comment"> * or more contributor license agreements.  See the NOTICE file</em>
<a class="jxr_linenumber" name="5" href="#5">5</a>   <em class="jxr_comment"> * distributed with this work for additional information</em>
<a class="jxr_linenumber" name="6" href="#6">6</a>   <em class="jxr_comment"> * regarding copyright ownership.  The ASF licenses this file</em>
<a class="jxr_linenumber" name="7" href="#7">7</a>   <em class="jxr_comment"> * to you under the Apache License, Version 2.0 (the</em>
<a class="jxr_linenumber" name="8" href="#8">8</a>   <em class="jxr_comment"> * "License"); you may not use this file except in compliance</em>
<a class="jxr_linenumber" name="9" href="#9">9</a>   <em class="jxr_comment"> * with the License.  You may obtain a copy of the License at</em>
<a class="jxr_linenumber" name="10" href="#10">10</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="11" href="#11">11</a>  <em class="jxr_comment"> *   <a href="http://www.apache.org/licenses/LICENSE-2.0" target="alexandria_uri">http://www.apache.org/licenses/LICENSE-2.0</a></em>
<a class="jxr_linenumber" name="12" href="#12">12</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="13" href="#13">13</a>  <em class="jxr_comment"> * Unless required by applicable law or agreed to in writing,</em>
<a class="jxr_linenumber" name="14" href="#14">14</a>  <em class="jxr_comment"> * software distributed under the License is distributed on an</em>
<a class="jxr_linenumber" name="15" href="#15">15</a>  <em class="jxr_comment"> * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY</em>
<a class="jxr_linenumber" name="16" href="#16">16</a>  <em class="jxr_comment"> * KIND, either express or implied.  See the License for the</em>
<a class="jxr_linenumber" name="17" href="#17">17</a>  <em class="jxr_comment"> * specific language governing permissions and limitations</em>
<a class="jxr_linenumber" name="18" href="#18">18</a>  <em class="jxr_comment"> * under the License.</em>
<a class="jxr_linenumber" name="19" href="#19">19</a>  <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="20" href="#20">20</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="21" href="#21">21</a>  <em class="jxr_comment"> * This software consists of voluntary contributions made by many</em>
<a class="jxr_linenumber" name="22" href="#22">22</a>  <em class="jxr_comment"> * individuals on behalf of the Apache Software Foundation.  For more</em>
<a class="jxr_linenumber" name="23" href="#23">23</a>  <em class="jxr_comment"> * information on the Apache Software Foundation, please see</em>
<a class="jxr_linenumber" name="24" href="#24">24</a>  <em class="jxr_comment"> * &lt;<a href="http://www.apache.org/&gt;." target="alexandria_uri">http://www.apache.org/&gt;.</a></em>
<a class="jxr_linenumber" name="25" href="#25">25</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="26" href="#26">26</a>  <em class="jxr_comment"> */</em>
<a class="jxr_linenumber" name="27" href="#27">27</a>  
<a class="jxr_linenumber" name="28" href="#28">28</a>  <strong class="jxr_keyword">package</strong> org.apache.http.protocol;
<a class="jxr_linenumber" name="29" href="#29">29</a>  
<a class="jxr_linenumber" name="30" href="#30">30</a>  <strong class="jxr_keyword">import</strong> java.io.IOException;
<a class="jxr_linenumber" name="31" href="#31">31</a>  
<a class="jxr_linenumber" name="32" href="#32">32</a>  <strong class="jxr_keyword">import</strong> org.apache.http.ConnectionReuseStrategy;
<a class="jxr_linenumber" name="33" href="#33">33</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpEntity;
<a class="jxr_linenumber" name="34" href="#34">34</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpEntityEnclosingRequest;
<a class="jxr_linenumber" name="35" href="#35">35</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpException;
<a class="jxr_linenumber" name="36" href="#36">36</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpRequest;
<a class="jxr_linenumber" name="37" href="#37">37</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpResponse;
<a class="jxr_linenumber" name="38" href="#38">38</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpResponseFactory;
<a class="jxr_linenumber" name="39" href="#39">39</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpServerConnection;
<a class="jxr_linenumber" name="40" href="#40">40</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpStatus;
<a class="jxr_linenumber" name="41" href="#41">41</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpVersion;
<a class="jxr_linenumber" name="42" href="#42">42</a>  <strong class="jxr_keyword">import</strong> org.apache.http.MethodNotSupportedException;
<a class="jxr_linenumber" name="43" href="#43">43</a>  <strong class="jxr_keyword">import</strong> org.apache.http.ProtocolException;
<a class="jxr_linenumber" name="44" href="#44">44</a>  <strong class="jxr_keyword">import</strong> org.apache.http.UnsupportedHttpVersionException;
<a class="jxr_linenumber" name="45" href="#45">45</a>  <strong class="jxr_keyword">import</strong> org.apache.http.annotation.Immutable;
<a class="jxr_linenumber" name="46" href="#46">46</a>  <strong class="jxr_keyword">import</strong> org.apache.http.entity.ByteArrayEntity;
<a class="jxr_linenumber" name="47" href="#47">47</a>  <strong class="jxr_keyword">import</strong> org.apache.http.impl.DefaultConnectionReuseStrategy;
<a class="jxr_linenumber" name="48" href="#48">48</a>  <strong class="jxr_keyword">import</strong> org.apache.http.impl.DefaultHttpResponseFactory;
<a class="jxr_linenumber" name="49" href="#49">49</a>  <strong class="jxr_keyword">import</strong> org.apache.http.params.HttpParams;
<a class="jxr_linenumber" name="50" href="#50">50</a>  <strong class="jxr_keyword">import</strong> org.apache.http.util.Args;
<a class="jxr_linenumber" name="51" href="#51">51</a>  <strong class="jxr_keyword">import</strong> org.apache.http.util.EncodingUtils;
<a class="jxr_linenumber" name="52" href="#52">52</a>  <strong class="jxr_keyword">import</strong> org.apache.http.util.EntityUtils;
<a class="jxr_linenumber" name="53" href="#53">53</a>  
<a class="jxr_linenumber" name="54" href="#54">54</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="55" href="#55">55</a>  <em class="jxr_javadoccomment"> * &lt;tt&gt;HttpService&lt;/tt&gt; is a server side HTTP protocol handler based on</em>
<a class="jxr_linenumber" name="56" href="#56">56</a>  <em class="jxr_javadoccomment"> * the classic (blocking) I/O model.</em>
<a class="jxr_linenumber" name="57" href="#57">57</a>  <em class="jxr_javadoccomment"> * &lt;p/&gt;</em>
<a class="jxr_linenumber" name="58" href="#58">58</a>  <em class="jxr_javadoccomment"> * &lt;tt&gt;HttpService&lt;/tt&gt; relies on {@link HttpProcessor} to generate mandatory</em>
<a class="jxr_linenumber" name="59" href="#59">59</a>  <em class="jxr_javadoccomment"> * protocol headers for all outgoing messages and apply common, cross-cutting</em>
<a class="jxr_linenumber" name="60" href="#60">60</a>  <em class="jxr_javadoccomment"> * message transformations to all incoming and outgoing messages, whereas</em>
<a class="jxr_linenumber" name="61" href="#61">61</a>  <em class="jxr_javadoccomment"> * individual {@link HttpRequestHandler}s are expected to implement</em>
<a class="jxr_linenumber" name="62" href="#62">62</a>  <em class="jxr_javadoccomment"> * application specific content generation and processing.</em>
<a class="jxr_linenumber" name="63" href="#63">63</a>  <em class="jxr_javadoccomment"> * &lt;p/&gt;</em>
<a class="jxr_linenumber" name="64" href="#64">64</a>  <em class="jxr_javadoccomment"> * &lt;tt&gt;HttpService&lt;/tt&gt; uses {@link HttpRequestHandlerMapper} to map</em>
<a class="jxr_linenumber" name="65" href="#65">65</a>  <em class="jxr_javadoccomment"> * matching request handler for a particular request URI of an incoming HTTP</em>
<a class="jxr_linenumber" name="66" href="#66">66</a>  <em class="jxr_javadoccomment"> * request.</em>
<a class="jxr_linenumber" name="67" href="#67">67</a>  <em class="jxr_javadoccomment"> * &lt;p/&gt;</em>
<a class="jxr_linenumber" name="68" href="#68">68</a>  <em class="jxr_javadoccomment"> * &lt;tt&gt;HttpService&lt;/tt&gt; can use optional {@link HttpExpectationVerifier}</em>
<a class="jxr_linenumber" name="69" href="#69">69</a>  <em class="jxr_javadoccomment"> * to ensure that incoming requests meet server's expectations.</em>
<a class="jxr_linenumber" name="70" href="#70">70</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="71" href="#71">71</a>  <em class="jxr_javadoccomment"> * @since 4.0</em>
<a class="jxr_linenumber" name="72" href="#72">72</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="73" href="#73">73</a>  @SuppressWarnings(<span class="jxr_string">"deprecation"</span>)
<a class="jxr_linenumber" name="74" href="#74">74</a>  @Immutable <em class="jxr_comment">// provided injected dependencies are immutable and deprecated methods are not used</em>
<a class="jxr_linenumber" name="75" href="#75">75</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../org/apache/http/protocol/HttpService.html">HttpService</a> {
<a class="jxr_linenumber" name="76" href="#76">76</a>  
<a class="jxr_linenumber" name="77" href="#77">77</a>      <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="78" href="#78">78</a>  <em class="jxr_javadoccomment">     * TODO: make all variables final in the next major version</em>
<a class="jxr_linenumber" name="79" href="#79">79</a>  <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="80" href="#80">80</a>      <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">volatile</strong> <a href="../../../../org/apache/http/params/HttpParams.html">HttpParams</a> params = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="81" href="#81">81</a>      <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">volatile</strong> <a href="../../../../org/apache/http/protocol/HttpProcessor.html">HttpProcessor</a> processor = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="82" href="#82">82</a>      <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">volatile</strong> <a href="../../../../org/apache/http/protocol/HttpRequestHandlerMapper.html">HttpRequestHandlerMapper</a> handlerMapper = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="83" href="#83">83</a>      <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">volatile</strong> <a href="../../../../org/apache/http/ConnectionReuseStrategy.html">ConnectionReuseStrategy</a> connStrategy = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="84" href="#84">84</a>      <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">volatile</strong> <a href="../../../../org/apache/http/HttpResponseFactory.html">HttpResponseFactory</a> responseFactory = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="85" href="#85">85</a>      <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">volatile</strong> <a href="../../../../org/apache/http/protocol/HttpExpectationVerifier.html">HttpExpectationVerifier</a> expectationVerifier = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="86" href="#86">86</a>  
<a class="jxr_linenumber" name="87" href="#87">87</a>      <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="88" href="#88">88</a>  <em class="jxr_javadoccomment">     * Create a new HTTP service.</em>
<a class="jxr_linenumber" name="89" href="#89">89</a>  <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="90" href="#90">90</a>  <em class="jxr_javadoccomment">     * @param processor            the processor to use on requests and responses</em>
<a class="jxr_linenumber" name="91" href="#91">91</a>  <em class="jxr_javadoccomment">     * @param connStrategy         the connection reuse strategy</em>
<a class="jxr_linenumber" name="92" href="#92">92</a>  <em class="jxr_javadoccomment">     * @param responseFactory      the response factory</em>
<a class="jxr_linenumber" name="93" href="#93">93</a>  <em class="jxr_javadoccomment">     * @param handlerResolver      the handler resolver. May be null.</em>
<a class="jxr_linenumber" name="94" href="#94">94</a>  <em class="jxr_javadoccomment">     * @param expectationVerifier  the expectation verifier. May be null.</em>
<a class="jxr_linenumber" name="95" href="#95">95</a>  <em class="jxr_javadoccomment">     * @param params               the HTTP parameters</em>
<a class="jxr_linenumber" name="96" href="#96">96</a>  <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="97" href="#97">97</a>  <em class="jxr_javadoccomment">     * @since 4.1</em>
<a class="jxr_linenumber" name="98" href="#98">98</a>  <em class="jxr_javadoccomment">     * @deprecated (4.3) use {@link HttpService#HttpService(HttpProcessor, ConnectionReuseStrategy,</em>
<a class="jxr_linenumber" name="99" href="#99">99</a>  <em class="jxr_javadoccomment">     *   HttpResponseFactory, HttpRequestHandlerMapper, HttpExpectationVerifier)}</em>
<a class="jxr_linenumber" name="100" href="#100">100</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="101" href="#101">101</a>     @Deprecated
<a class="jxr_linenumber" name="102" href="#102">102</a>     <strong class="jxr_keyword">public</strong> <a href="../../../../org/apache/http/protocol/HttpService.html">HttpService</a>(
<a class="jxr_linenumber" name="103" href="#103">103</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/protocol/HttpProcessor.html">HttpProcessor</a> processor,
<a class="jxr_linenumber" name="104" href="#104">104</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/ConnectionReuseStrategy.html">ConnectionReuseStrategy</a> connStrategy,
<a class="jxr_linenumber" name="105" href="#105">105</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/HttpResponseFactory.html">HttpResponseFactory</a> responseFactory,
<a class="jxr_linenumber" name="106" href="#106">106</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/protocol/HttpRequestHandlerResolver.html">HttpRequestHandlerResolver</a> handlerResolver,
<a class="jxr_linenumber" name="107" href="#107">107</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/protocol/HttpExpectationVerifier.html">HttpExpectationVerifier</a> expectationVerifier,
<a class="jxr_linenumber" name="108" href="#108">108</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/params/HttpParams.html">HttpParams</a> params) {
<a class="jxr_linenumber" name="109" href="#109">109</a>         <strong class="jxr_keyword">this</strong>(processor,
<a class="jxr_linenumber" name="110" href="#110">110</a>              connStrategy,
<a class="jxr_linenumber" name="111" href="#111">111</a>              responseFactory,
<a class="jxr_linenumber" name="112" href="#112">112</a>              <strong class="jxr_keyword">new</strong> <a href="../../../../org/apache/http/protocol/HttpService.html">HttpRequestHandlerResolverAdapter</a>(handlerResolver),
<a class="jxr_linenumber" name="113" href="#113">113</a>              expectationVerifier);
<a class="jxr_linenumber" name="114" href="#114">114</a>         <strong class="jxr_keyword">this</strong>.params = params;
<a class="jxr_linenumber" name="115" href="#115">115</a>     }
<a class="jxr_linenumber" name="116" href="#116">116</a> 
<a class="jxr_linenumber" name="117" href="#117">117</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="118" href="#118">118</a> <em class="jxr_javadoccomment">     * Create a new HTTP service.</em>
<a class="jxr_linenumber" name="119" href="#119">119</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="120" href="#120">120</a> <em class="jxr_javadoccomment">     * @param processor            the processor to use on requests and responses</em>
<a class="jxr_linenumber" name="121" href="#121">121</a> <em class="jxr_javadoccomment">     * @param connStrategy         the connection reuse strategy</em>
<a class="jxr_linenumber" name="122" href="#122">122</a> <em class="jxr_javadoccomment">     * @param responseFactory      the response factory</em>
<a class="jxr_linenumber" name="123" href="#123">123</a> <em class="jxr_javadoccomment">     * @param handlerResolver      the handler resolver. May be null.</em>
<a class="jxr_linenumber" name="124" href="#124">124</a> <em class="jxr_javadoccomment">     * @param params               the HTTP parameters</em>
<a class="jxr_linenumber" name="125" href="#125">125</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="126" href="#126">126</a> <em class="jxr_javadoccomment">     * @since 4.1</em>
<a class="jxr_linenumber" name="127" href="#127">127</a> <em class="jxr_javadoccomment">     * @deprecated (4.3) use {@link HttpService#HttpService(HttpProcessor, ConnectionReuseStrategy,</em>
<a class="jxr_linenumber" name="128" href="#128">128</a> <em class="jxr_javadoccomment">     *   HttpResponseFactory, HttpRequestHandlerMapper)}</em>
<a class="jxr_linenumber" name="129" href="#129">129</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="130" href="#130">130</a>     @Deprecated
<a class="jxr_linenumber" name="131" href="#131">131</a>     <strong class="jxr_keyword">public</strong> <a href="../../../../org/apache/http/protocol/HttpService.html">HttpService</a>(
<a class="jxr_linenumber" name="132" href="#132">132</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/protocol/HttpProcessor.html">HttpProcessor</a> processor,
<a class="jxr_linenumber" name="133" href="#133">133</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/ConnectionReuseStrategy.html">ConnectionReuseStrategy</a> connStrategy,
<a class="jxr_linenumber" name="134" href="#134">134</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/HttpResponseFactory.html">HttpResponseFactory</a> responseFactory,
<a class="jxr_linenumber" name="135" href="#135">135</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/protocol/HttpRequestHandlerResolver.html">HttpRequestHandlerResolver</a> handlerResolver,
<a class="jxr_linenumber" name="136" href="#136">136</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/params/HttpParams.html">HttpParams</a> params) {
<a class="jxr_linenumber" name="137" href="#137">137</a>         <strong class="jxr_keyword">this</strong>(processor,
<a class="jxr_linenumber" name="138" href="#138">138</a>              connStrategy,
<a class="jxr_linenumber" name="139" href="#139">139</a>              responseFactory,
<a class="jxr_linenumber" name="140" href="#140">140</a>              <strong class="jxr_keyword">new</strong> <a href="../../../../org/apache/http/protocol/HttpService.html">HttpRequestHandlerResolverAdapter</a>(handlerResolver),
<a class="jxr_linenumber" name="141" href="#141">141</a>              <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="142" href="#142">142</a>         <strong class="jxr_keyword">this</strong>.params = params;
<a class="jxr_linenumber" name="143" href="#143">143</a>     }
<a class="jxr_linenumber" name="144" href="#144">144</a> 
<a class="jxr_linenumber" name="145" href="#145">145</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="146" href="#146">146</a> <em class="jxr_javadoccomment">     * Create a new HTTP service.</em>
<a class="jxr_linenumber" name="147" href="#147">147</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="148" href="#148">148</a> <em class="jxr_javadoccomment">     * @param proc             the processor to use on requests and responses</em>
<a class="jxr_linenumber" name="149" href="#149">149</a> <em class="jxr_javadoccomment">     * @param connStrategy     the connection reuse strategy</em>
<a class="jxr_linenumber" name="150" href="#150">150</a> <em class="jxr_javadoccomment">     * @param responseFactory  the response factory</em>
<a class="jxr_linenumber" name="151" href="#151">151</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="152" href="#152">152</a> <em class="jxr_javadoccomment">     * @deprecated (4.1) use {@link HttpService#HttpService(HttpProcessor,</em>
<a class="jxr_linenumber" name="153" href="#153">153</a> <em class="jxr_javadoccomment">     *  ConnectionReuseStrategy, HttpResponseFactory, HttpRequestHandlerResolver, HttpParams)}</em>
<a class="jxr_linenumber" name="154" href="#154">154</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="155" href="#155">155</a>     @Deprecated
<a class="jxr_linenumber" name="156" href="#156">156</a>     <strong class="jxr_keyword">public</strong> <a href="../../../../org/apache/http/protocol/HttpService.html">HttpService</a>(
<a class="jxr_linenumber" name="157" href="#157">157</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/protocol/HttpProcessor.html">HttpProcessor</a> proc,
<a class="jxr_linenumber" name="158" href="#158">158</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/ConnectionReuseStrategy.html">ConnectionReuseStrategy</a> connStrategy,
<a class="jxr_linenumber" name="159" href="#159">159</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/HttpResponseFactory.html">HttpResponseFactory</a> responseFactory) {
<a class="jxr_linenumber" name="160" href="#160">160</a>         <strong class="jxr_keyword">super</strong>();
<a class="jxr_linenumber" name="161" href="#161">161</a>         setHttpProcessor(proc);
<a class="jxr_linenumber" name="162" href="#162">162</a>         setConnReuseStrategy(connStrategy);
<a class="jxr_linenumber" name="163" href="#163">163</a>         setResponseFactory(responseFactory);
<a class="jxr_linenumber" name="164" href="#164">164</a>     }
<a class="jxr_linenumber" name="165" href="#165">165</a> 
<a class="jxr_linenumber" name="166" href="#166">166</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="167" href="#167">167</a> <em class="jxr_javadoccomment">     * Create a new HTTP service.</em>
<a class="jxr_linenumber" name="168" href="#168">168</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="169" href="#169">169</a> <em class="jxr_javadoccomment">     * @param processor the processor to use on requests and responses</em>
<a class="jxr_linenumber" name="170" href="#170">170</a> <em class="jxr_javadoccomment">     * @param connStrategy the connection reuse strategy. If &lt;code&gt;null&lt;/code&gt;</em>
<a class="jxr_linenumber" name="171" href="#171">171</a> <em class="jxr_javadoccomment">     *   {@link DefaultConnectionReuseStrategy#INSTANCE} will be used.</em>
<a class="jxr_linenumber" name="172" href="#172">172</a> <em class="jxr_javadoccomment">     * @param responseFactory  the response factory. If &lt;code&gt;null&lt;/code&gt;</em>
<a class="jxr_linenumber" name="173" href="#173">173</a> <em class="jxr_javadoccomment">     *   {@link DefaultHttpResponseFactory#INSTANCE} will be used.</em>
<a class="jxr_linenumber" name="174" href="#174">174</a> <em class="jxr_javadoccomment">     * @param handlerMapper  the handler mapper. May be null.</em>
<a class="jxr_linenumber" name="175" href="#175">175</a> <em class="jxr_javadoccomment">     * @param expectationVerifier the expectation verifier. May be null.</em>
<a class="jxr_linenumber" name="176" href="#176">176</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="177" href="#177">177</a> <em class="jxr_javadoccomment">     * @since 4.3</em>
<a class="jxr_linenumber" name="178" href="#178">178</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="179" href="#179">179</a>     <strong class="jxr_keyword">public</strong> <a href="../../../../org/apache/http/protocol/HttpService.html">HttpService</a>(
<a class="jxr_linenumber" name="180" href="#180">180</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/protocol/HttpProcessor.html">HttpProcessor</a> processor,
<a class="jxr_linenumber" name="181" href="#181">181</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/ConnectionReuseStrategy.html">ConnectionReuseStrategy</a> connStrategy,
<a class="jxr_linenumber" name="182" href="#182">182</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/HttpResponseFactory.html">HttpResponseFactory</a> responseFactory,
<a class="jxr_linenumber" name="183" href="#183">183</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/protocol/HttpRequestHandlerMapper.html">HttpRequestHandlerMapper</a> handlerMapper,
<a class="jxr_linenumber" name="184" href="#184">184</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/protocol/HttpExpectationVerifier.html">HttpExpectationVerifier</a> expectationVerifier) {
<a class="jxr_linenumber" name="185" href="#185">185</a>         <strong class="jxr_keyword">super</strong>();
<a class="jxr_linenumber" name="186" href="#186">186</a>         <strong class="jxr_keyword">this</strong>.processor =  Args.notNull(processor, <span class="jxr_string">"HTTP processor"</span>);
<a class="jxr_linenumber" name="187" href="#187">187</a>         <strong class="jxr_keyword">this</strong>.connStrategy = connStrategy != <strong class="jxr_keyword">null</strong> ? connStrategy :
<a class="jxr_linenumber" name="188" href="#188">188</a>             DefaultConnectionReuseStrategy.INSTANCE;
<a class="jxr_linenumber" name="189" href="#189">189</a>         <strong class="jxr_keyword">this</strong>.responseFactory = responseFactory != <strong class="jxr_keyword">null</strong> ? responseFactory :
<a class="jxr_linenumber" name="190" href="#190">190</a>             DefaultHttpResponseFactory.INSTANCE;
<a class="jxr_linenumber" name="191" href="#191">191</a>         <strong class="jxr_keyword">this</strong>.handlerMapper = handlerMapper;
<a class="jxr_linenumber" name="192" href="#192">192</a>         <strong class="jxr_keyword">this</strong>.expectationVerifier = expectationVerifier;
<a class="jxr_linenumber" name="193" href="#193">193</a>     }
<a class="jxr_linenumber" name="194" href="#194">194</a> 
<a class="jxr_linenumber" name="195" href="#195">195</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="196" href="#196">196</a> <em class="jxr_javadoccomment">     * Create a new HTTP service.</em>
<a class="jxr_linenumber" name="197" href="#197">197</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="198" href="#198">198</a> <em class="jxr_javadoccomment">     * @param processor the processor to use on requests and responses</em>
<a class="jxr_linenumber" name="199" href="#199">199</a> <em class="jxr_javadoccomment">     * @param connStrategy the connection reuse strategy. If &lt;code&gt;null&lt;/code&gt;</em>
<a class="jxr_linenumber" name="200" href="#200">200</a> <em class="jxr_javadoccomment">     *   {@link DefaultConnectionReuseStrategy#INSTANCE} will be used.</em>
<a class="jxr_linenumber" name="201" href="#201">201</a> <em class="jxr_javadoccomment">     * @param responseFactory  the response factory. If &lt;code&gt;null&lt;/code&gt;</em>
<a class="jxr_linenumber" name="202" href="#202">202</a> <em class="jxr_javadoccomment">     *   {@link DefaultHttpResponseFactory#INSTANCE} will be used.</em>
<a class="jxr_linenumber" name="203" href="#203">203</a> <em class="jxr_javadoccomment">     * @param handlerMapper  the handler mapper. May be null.</em>
<a class="jxr_linenumber" name="204" href="#204">204</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="205" href="#205">205</a> <em class="jxr_javadoccomment">     * @since 4.3</em>
<a class="jxr_linenumber" name="206" href="#206">206</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="207" href="#207">207</a>     <strong class="jxr_keyword">public</strong> <a href="../../../../org/apache/http/protocol/HttpService.html">HttpService</a>(
<a class="jxr_linenumber" name="208" href="#208">208</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/protocol/HttpProcessor.html">HttpProcessor</a> processor,
<a class="jxr_linenumber" name="209" href="#209">209</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/ConnectionReuseStrategy.html">ConnectionReuseStrategy</a> connStrategy,
<a class="jxr_linenumber" name="210" href="#210">210</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/HttpResponseFactory.html">HttpResponseFactory</a> responseFactory,
<a class="jxr_linenumber" name="211" href="#211">211</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/protocol/HttpRequestHandlerMapper.html">HttpRequestHandlerMapper</a> handlerMapper) {
<a class="jxr_linenumber" name="212" href="#212">212</a>         <strong class="jxr_keyword">this</strong>(processor, connStrategy, responseFactory, handlerMapper, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="213" href="#213">213</a>     }
<a class="jxr_linenumber" name="214" href="#214">214</a> 
<a class="jxr_linenumber" name="215" href="#215">215</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="216" href="#216">216</a> <em class="jxr_javadoccomment">     * Create a new HTTP service.</em>
<a class="jxr_linenumber" name="217" href="#217">217</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="218" href="#218">218</a> <em class="jxr_javadoccomment">     * @param processor the processor to use on requests and responses</em>
<a class="jxr_linenumber" name="219" href="#219">219</a> <em class="jxr_javadoccomment">     * @param handlerMapper  the handler mapper. May be null.</em>
<a class="jxr_linenumber" name="220" href="#220">220</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="221" href="#221">221</a> <em class="jxr_javadoccomment">     * @since 4.3</em>
<a class="jxr_linenumber" name="222" href="#222">222</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="223" href="#223">223</a>     <strong class="jxr_keyword">public</strong> <a href="../../../../org/apache/http/protocol/HttpService.html">HttpService</a>(
<a class="jxr_linenumber" name="224" href="#224">224</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/protocol/HttpProcessor.html">HttpProcessor</a> processor, <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/protocol/HttpRequestHandlerMapper.html">HttpRequestHandlerMapper</a> handlerMapper) {
<a class="jxr_linenumber" name="225" href="#225">225</a>         <strong class="jxr_keyword">this</strong>(processor, <strong class="jxr_keyword">null</strong>, <strong class="jxr_keyword">null</strong>, handlerMapper, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="226" href="#226">226</a>     }
<a class="jxr_linenumber" name="227" href="#227">227</a> 
<a class="jxr_linenumber" name="228" href="#228">228</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="229" href="#229">229</a> <em class="jxr_javadoccomment">     * @deprecated (4.1) set {@link HttpProcessor} using constructor</em>
<a class="jxr_linenumber" name="230" href="#230">230</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="231" href="#231">231</a>     @Deprecated
<a class="jxr_linenumber" name="232" href="#232">232</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> setHttpProcessor(<strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/protocol/HttpProcessor.html">HttpProcessor</a> processor) {
<a class="jxr_linenumber" name="233" href="#233">233</a>         Args.notNull(processor, <span class="jxr_string">"HTTP processor"</span>);
<a class="jxr_linenumber" name="234" href="#234">234</a>         <strong class="jxr_keyword">this</strong>.processor = processor;
<a class="jxr_linenumber" name="235" href="#235">235</a>     }
<a class="jxr_linenumber" name="236" href="#236">236</a> 
<a class="jxr_linenumber" name="237" href="#237">237</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="238" href="#238">238</a> <em class="jxr_javadoccomment">     * @deprecated (4.1) set {@link ConnectionReuseStrategy} using constructor</em>
<a class="jxr_linenumber" name="239" href="#239">239</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="240" href="#240">240</a>     @Deprecated
<a class="jxr_linenumber" name="241" href="#241">241</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> setConnReuseStrategy(<strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/ConnectionReuseStrategy.html">ConnectionReuseStrategy</a> connStrategy) {
<a class="jxr_linenumber" name="242" href="#242">242</a>         Args.notNull(connStrategy, <span class="jxr_string">"Connection reuse strategy"</span>);
<a class="jxr_linenumber" name="243" href="#243">243</a>         <strong class="jxr_keyword">this</strong>.connStrategy = connStrategy;
<a class="jxr_linenumber" name="244" href="#244">244</a>     }
<a class="jxr_linenumber" name="245" href="#245">245</a> 
<a class="jxr_linenumber" name="246" href="#246">246</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="247" href="#247">247</a> <em class="jxr_javadoccomment">     * @deprecated (4.1) set {@link HttpResponseFactory} using constructor</em>
<a class="jxr_linenumber" name="248" href="#248">248</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="249" href="#249">249</a>     @Deprecated
<a class="jxr_linenumber" name="250" href="#250">250</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> setResponseFactory(<strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/HttpResponseFactory.html">HttpResponseFactory</a> responseFactory) {
<a class="jxr_linenumber" name="251" href="#251">251</a>         Args.notNull(responseFactory, <span class="jxr_string">"Response factory"</span>);
<a class="jxr_linenumber" name="252" href="#252">252</a>         <strong class="jxr_keyword">this</strong>.responseFactory = responseFactory;
<a class="jxr_linenumber" name="253" href="#253">253</a>     }
<a class="jxr_linenumber" name="254" href="#254">254</a> 
<a class="jxr_linenumber" name="255" href="#255">255</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="256" href="#256">256</a> <em class="jxr_javadoccomment">     * @deprecated (4.1) set {@link HttpResponseFactory} using constructor</em>
<a class="jxr_linenumber" name="257" href="#257">257</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="258" href="#258">258</a>     @Deprecated
<a class="jxr_linenumber" name="259" href="#259">259</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> setParams(<strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/params/HttpParams.html">HttpParams</a> params) {
<a class="jxr_linenumber" name="260" href="#260">260</a>         <strong class="jxr_keyword">this</strong>.params = params;
<a class="jxr_linenumber" name="261" href="#261">261</a>     }
<a class="jxr_linenumber" name="262" href="#262">262</a> 
<a class="jxr_linenumber" name="263" href="#263">263</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="264" href="#264">264</a> <em class="jxr_javadoccomment">     * @deprecated (4.1) set {@link HttpRequestHandlerResolver} using constructor</em>
<a class="jxr_linenumber" name="265" href="#265">265</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="266" href="#266">266</a>     @Deprecated
<a class="jxr_linenumber" name="267" href="#267">267</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> setHandlerResolver(<strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/protocol/HttpRequestHandlerResolver.html">HttpRequestHandlerResolver</a> handlerResolver) {
<a class="jxr_linenumber" name="268" href="#268">268</a>         <strong class="jxr_keyword">this</strong>.handlerMapper = <strong class="jxr_keyword">new</strong> <a href="../../../../org/apache/http/protocol/HttpService.html">HttpRequestHandlerResolverAdapter</a>(handlerResolver);
<a class="jxr_linenumber" name="269" href="#269">269</a>     }
<a class="jxr_linenumber" name="270" href="#270">270</a> 
<a class="jxr_linenumber" name="271" href="#271">271</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="272" href="#272">272</a> <em class="jxr_javadoccomment">     * @deprecated (4.1) set {@link HttpExpectationVerifier} using constructor</em>
<a class="jxr_linenumber" name="273" href="#273">273</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="274" href="#274">274</a>     @Deprecated
<a class="jxr_linenumber" name="275" href="#275">275</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> setExpectationVerifier(<strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/protocol/HttpExpectationVerifier.html">HttpExpectationVerifier</a> expectationVerifier) {
<a class="jxr_linenumber" name="276" href="#276">276</a>         <strong class="jxr_keyword">this</strong>.expectationVerifier = expectationVerifier;
<a class="jxr_linenumber" name="277" href="#277">277</a>     }
<a class="jxr_linenumber" name="278" href="#278">278</a> 
<a class="jxr_linenumber" name="279" href="#279">279</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="280" href="#280">280</a> <em class="jxr_javadoccomment">     * @deprecated (4.3) no longer used.</em>
<a class="jxr_linenumber" name="281" href="#281">281</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="282" href="#282">282</a>     @Deprecated
<a class="jxr_linenumber" name="283" href="#283">283</a>     <strong class="jxr_keyword">public</strong> <a href="../../../../org/apache/http/params/HttpParams.html">HttpParams</a> getParams() {
<a class="jxr_linenumber" name="284" href="#284">284</a>         <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">this</strong>.params;
<a class="jxr_linenumber" name="285" href="#285">285</a>     }
<a class="jxr_linenumber" name="286" href="#286">286</a> 
<a class="jxr_linenumber" name="287" href="#287">287</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="288" href="#288">288</a> <em class="jxr_javadoccomment">     * Handles receives one HTTP request over the given connection within the</em>
<a class="jxr_linenumber" name="289" href="#289">289</a> <em class="jxr_javadoccomment">     * given execution context and sends a response back to the client.</em>
<a class="jxr_linenumber" name="290" href="#290">290</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="291" href="#291">291</a> <em class="jxr_javadoccomment">     * @param conn the active connection to the client</em>
<a class="jxr_linenumber" name="292" href="#292">292</a> <em class="jxr_javadoccomment">     * @param context the actual execution context.</em>
<a class="jxr_linenumber" name="293" href="#293">293</a> <em class="jxr_javadoccomment">     * @throws IOException in case of an I/O error.</em>
<a class="jxr_linenumber" name="294" href="#294">294</a> <em class="jxr_javadoccomment">     * @throws HttpException in case of HTTP protocol violation or a processing</em>
<a class="jxr_linenumber" name="295" href="#295">295</a> <em class="jxr_javadoccomment">     *   problem.</em>
<a class="jxr_linenumber" name="296" href="#296">296</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="297" href="#297">297</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> handleRequest(
<a class="jxr_linenumber" name="298" href="#298">298</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/HttpServerConnection.html">HttpServerConnection</a> conn,
<a class="jxr_linenumber" name="299" href="#299">299</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/protocol/HttpContext.html">HttpContext</a> context) <strong class="jxr_keyword">throws</strong> IOException, HttpException {
<a class="jxr_linenumber" name="300" href="#300">300</a> 
<a class="jxr_linenumber" name="301" href="#301">301</a>         context.setAttribute(ExecutionContext.HTTP_CONNECTION, conn);
<a class="jxr_linenumber" name="302" href="#302">302</a> 
<a class="jxr_linenumber" name="303" href="#303">303</a>         <a href="../../../../org/apache/http/HttpResponse.html">HttpResponse</a> response = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="304" href="#304">304</a> 
<a class="jxr_linenumber" name="305" href="#305">305</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="306" href="#306">306</a> 
<a class="jxr_linenumber" name="307" href="#307">307</a>             <a href="../../../../org/apache/http/HttpRequest.html">HttpRequest</a> request = conn.receiveRequestHeader();
<a class="jxr_linenumber" name="308" href="#308">308</a>             <strong class="jxr_keyword">if</strong> (request instanceof HttpEntityEnclosingRequest) {
<a class="jxr_linenumber" name="309" href="#309">309</a> 
<a class="jxr_linenumber" name="310" href="#310">310</a>                 <strong class="jxr_keyword">if</strong> (((HttpEntityEnclosingRequest) request).expectContinue()) {
<a class="jxr_linenumber" name="311" href="#311">311</a>                     response = <strong class="jxr_keyword">this</strong>.responseFactory.newHttpResponse(HttpVersion.HTTP_1_1,
<a class="jxr_linenumber" name="312" href="#312">312</a>                             HttpStatus.SC_CONTINUE, context);
<a class="jxr_linenumber" name="313" href="#313">313</a>                     <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.expectationVerifier != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="314" href="#314">314</a>                         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="315" href="#315">315</a>                             <strong class="jxr_keyword">this</strong>.expectationVerifier.verify(request, response, context);
<a class="jxr_linenumber" name="316" href="#316">316</a>                         } <strong class="jxr_keyword">catch</strong> (HttpException ex) {
<a class="jxr_linenumber" name="317" href="#317">317</a>                             response = <strong class="jxr_keyword">this</strong>.responseFactory.newHttpResponse(HttpVersion.HTTP_1_0,
<a class="jxr_linenumber" name="318" href="#318">318</a>                                     HttpStatus.SC_INTERNAL_SERVER_ERROR, context);
<a class="jxr_linenumber" name="319" href="#319">319</a>                             handleException(ex, response);
<a class="jxr_linenumber" name="320" href="#320">320</a>                         }
<a class="jxr_linenumber" name="321" href="#321">321</a>                     }
<a class="jxr_linenumber" name="322" href="#322">322</a>                     <strong class="jxr_keyword">if</strong> (response.getStatusLine().getStatusCode() &lt; 200) {
<a class="jxr_linenumber" name="323" href="#323">323</a>                         <em class="jxr_comment">// Send 1xx response indicating the server expections</em>
<a class="jxr_linenumber" name="324" href="#324">324</a>                         <em class="jxr_comment">// have been met</em>
<a class="jxr_linenumber" name="325" href="#325">325</a>                         conn.sendResponseHeader(response);
<a class="jxr_linenumber" name="326" href="#326">326</a>                         conn.flush();
<a class="jxr_linenumber" name="327" href="#327">327</a>                         response = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="328" href="#328">328</a>                         conn.receiveRequestEntity((HttpEntityEnclosingRequest) request);
<a class="jxr_linenumber" name="329" href="#329">329</a>                     }
<a class="jxr_linenumber" name="330" href="#330">330</a>                 } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="331" href="#331">331</a>                     conn.receiveRequestEntity((HttpEntityEnclosingRequest) request);
<a class="jxr_linenumber" name="332" href="#332">332</a>                 }
<a class="jxr_linenumber" name="333" href="#333">333</a>             }
<a class="jxr_linenumber" name="334" href="#334">334</a> 
<a class="jxr_linenumber" name="335" href="#335">335</a>             context.setAttribute(ExecutionContext.HTTP_REQUEST, request);
<a class="jxr_linenumber" name="336" href="#336">336</a> 
<a class="jxr_linenumber" name="337" href="#337">337</a>             <strong class="jxr_keyword">if</strong> (response == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="338" href="#338">338</a>                 response = <strong class="jxr_keyword">this</strong>.responseFactory.newHttpResponse(HttpVersion.HTTP_1_1,
<a class="jxr_linenumber" name="339" href="#339">339</a>                         HttpStatus.SC_OK, context);
<a class="jxr_linenumber" name="340" href="#340">340</a>                 <strong class="jxr_keyword">this</strong>.processor.process(request, context);
<a class="jxr_linenumber" name="341" href="#341">341</a>                 doService(request, response, context);
<a class="jxr_linenumber" name="342" href="#342">342</a>             }
<a class="jxr_linenumber" name="343" href="#343">343</a> 
<a class="jxr_linenumber" name="344" href="#344">344</a>             <em class="jxr_comment">// Make sure the request content is fully consumed</em>
<a class="jxr_linenumber" name="345" href="#345">345</a>             <strong class="jxr_keyword">if</strong> (request instanceof HttpEntityEnclosingRequest) {
<a class="jxr_linenumber" name="346" href="#346">346</a>                 <a href="../../../../org/apache/http/HttpEntity.html">HttpEntity</a> entity = ((HttpEntityEnclosingRequest)request).getEntity();
<a class="jxr_linenumber" name="347" href="#347">347</a>                 EntityUtils.consume(entity);
<a class="jxr_linenumber" name="348" href="#348">348</a>             }
<a class="jxr_linenumber" name="349" href="#349">349</a> 
<a class="jxr_linenumber" name="350" href="#350">350</a>         } <strong class="jxr_keyword">catch</strong> (HttpException ex) {
<a class="jxr_linenumber" name="351" href="#351">351</a>             response = <strong class="jxr_keyword">this</strong>.responseFactory.newHttpResponse
<a class="jxr_linenumber" name="352" href="#352">352</a>                 (HttpVersion.HTTP_1_0, HttpStatus.SC_INTERNAL_SERVER_ERROR,
<a class="jxr_linenumber" name="353" href="#353">353</a>                  context);
<a class="jxr_linenumber" name="354" href="#354">354</a>             handleException(ex, response);
<a class="jxr_linenumber" name="355" href="#355">355</a>         }
<a class="jxr_linenumber" name="356" href="#356">356</a> 
<a class="jxr_linenumber" name="357" href="#357">357</a>         context.setAttribute(ExecutionContext.HTTP_RESPONSE, response);
<a class="jxr_linenumber" name="358" href="#358">358</a> 
<a class="jxr_linenumber" name="359" href="#359">359</a>         <strong class="jxr_keyword">this</strong>.processor.process(response, context);
<a class="jxr_linenumber" name="360" href="#360">360</a>         conn.sendResponseHeader(response);
<a class="jxr_linenumber" name="361" href="#361">361</a>         conn.sendResponseEntity(response);
<a class="jxr_linenumber" name="362" href="#362">362</a>         conn.flush();
<a class="jxr_linenumber" name="363" href="#363">363</a> 
<a class="jxr_linenumber" name="364" href="#364">364</a>         <strong class="jxr_keyword">if</strong> (!<strong class="jxr_keyword">this</strong>.connStrategy.keepAlive(response, context)) {
<a class="jxr_linenumber" name="365" href="#365">365</a>             conn.close();
<a class="jxr_linenumber" name="366" href="#366">366</a>         }
<a class="jxr_linenumber" name="367" href="#367">367</a>     }
<a class="jxr_linenumber" name="368" href="#368">368</a> 
<a class="jxr_linenumber" name="369" href="#369">369</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="370" href="#370">370</a> <em class="jxr_javadoccomment">     * Handles the given exception and generates an HTTP response to be sent</em>
<a class="jxr_linenumber" name="371" href="#371">371</a> <em class="jxr_javadoccomment">     * back to the client to inform about the exceptional condition encountered</em>
<a class="jxr_linenumber" name="372" href="#372">372</a> <em class="jxr_javadoccomment">     * in the course of the request processing.</em>
<a class="jxr_linenumber" name="373" href="#373">373</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="374" href="#374">374</a> <em class="jxr_javadoccomment">     * @param ex the exception.</em>
<a class="jxr_linenumber" name="375" href="#375">375</a> <em class="jxr_javadoccomment">     * @param response the HTTP response.</em>
<a class="jxr_linenumber" name="376" href="#376">376</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="377" href="#377">377</a>     <strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> handleException(<strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/HttpException.html">HttpException</a> ex, <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/HttpResponse.html">HttpResponse</a> response) {
<a class="jxr_linenumber" name="378" href="#378">378</a>         <strong class="jxr_keyword">if</strong> (ex instanceof MethodNotSupportedException) {
<a class="jxr_linenumber" name="379" href="#379">379</a>             response.setStatusCode(HttpStatus.SC_NOT_IMPLEMENTED);
<a class="jxr_linenumber" name="380" href="#380">380</a>         } <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (ex instanceof UnsupportedHttpVersionException) {
<a class="jxr_linenumber" name="381" href="#381">381</a>             response.setStatusCode(HttpStatus.SC_HTTP_VERSION_NOT_SUPPORTED);
<a class="jxr_linenumber" name="382" href="#382">382</a>         } <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (ex instanceof ProtocolException) {
<a class="jxr_linenumber" name="383" href="#383">383</a>             response.setStatusCode(HttpStatus.SC_BAD_REQUEST);
<a class="jxr_linenumber" name="384" href="#384">384</a>         } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="385" href="#385">385</a>             response.setStatusCode(HttpStatus.SC_INTERNAL_SERVER_ERROR);
<a class="jxr_linenumber" name="386" href="#386">386</a>         }
<a class="jxr_linenumber" name="387" href="#387">387</a>         String message = ex.getMessage();
<a class="jxr_linenumber" name="388" href="#388">388</a>         <strong class="jxr_keyword">if</strong> (message == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="389" href="#389">389</a>             message = ex.toString();
<a class="jxr_linenumber" name="390" href="#390">390</a>         }
<a class="jxr_linenumber" name="391" href="#391">391</a>         byte[] msg = EncodingUtils.getAsciiBytes(message);
<a class="jxr_linenumber" name="392" href="#392">392</a>         <a href="../../../../org/apache/http/entity/ByteArrayEntity.html">ByteArrayEntity</a> entity = <strong class="jxr_keyword">new</strong> <a href="../../../../org/apache/http/entity/ByteArrayEntity.html">ByteArrayEntity</a>(msg);
<a class="jxr_linenumber" name="393" href="#393">393</a>         entity.setContentType(<span class="jxr_string">"text/plain; charset=US-ASCII"</span>);
<a class="jxr_linenumber" name="394" href="#394">394</a>         response.setEntity(entity);
<a class="jxr_linenumber" name="395" href="#395">395</a>     }
<a class="jxr_linenumber" name="396" href="#396">396</a> 
<a class="jxr_linenumber" name="397" href="#397">397</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="398" href="#398">398</a> <em class="jxr_javadoccomment">     * The default implementation of this method attempts to resolve an</em>
<a class="jxr_linenumber" name="399" href="#399">399</a> <em class="jxr_javadoccomment">     * {@link HttpRequestHandler} for the request URI of the given request</em>
<a class="jxr_linenumber" name="400" href="#400">400</a> <em class="jxr_javadoccomment">     * and, if found, executes its</em>
<a class="jxr_linenumber" name="401" href="#401">401</a> <em class="jxr_javadoccomment">     * {@link HttpRequestHandler#handle(HttpRequest, HttpResponse, HttpContext)}</em>
<a class="jxr_linenumber" name="402" href="#402">402</a> <em class="jxr_javadoccomment">     * method.</em>
<a class="jxr_linenumber" name="403" href="#403">403</a> <em class="jxr_javadoccomment">     * &lt;p&gt;</em>
<a class="jxr_linenumber" name="404" href="#404">404</a> <em class="jxr_javadoccomment">     * Super-classes can override this method in order to provide a custom</em>
<a class="jxr_linenumber" name="405" href="#405">405</a> <em class="jxr_javadoccomment">     * implementation of the request processing logic.</em>
<a class="jxr_linenumber" name="406" href="#406">406</a> <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="407" href="#407">407</a> <em class="jxr_javadoccomment">     * @param request the HTTP request.</em>
<a class="jxr_linenumber" name="408" href="#408">408</a> <em class="jxr_javadoccomment">     * @param response the HTTP response.</em>
<a class="jxr_linenumber" name="409" href="#409">409</a> <em class="jxr_javadoccomment">     * @param context the execution context.</em>
<a class="jxr_linenumber" name="410" href="#410">410</a> <em class="jxr_javadoccomment">     * @throws IOException in case of an I/O error.</em>
<a class="jxr_linenumber" name="411" href="#411">411</a> <em class="jxr_javadoccomment">     * @throws HttpException in case of HTTP protocol violation or a processing</em>
<a class="jxr_linenumber" name="412" href="#412">412</a> <em class="jxr_javadoccomment">     *   problem.</em>
<a class="jxr_linenumber" name="413" href="#413">413</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="414" href="#414">414</a>     <strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> doService(
<a class="jxr_linenumber" name="415" href="#415">415</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/HttpRequest.html">HttpRequest</a> request,
<a class="jxr_linenumber" name="416" href="#416">416</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/HttpResponse.html">HttpResponse</a> response,
<a class="jxr_linenumber" name="417" href="#417">417</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/protocol/HttpContext.html">HttpContext</a> context) <strong class="jxr_keyword">throws</strong> HttpException, IOException {
<a class="jxr_linenumber" name="418" href="#418">418</a>         <a href="../../../../org/apache/http/protocol/HttpRequestHandler.html">HttpRequestHandler</a> handler = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="419" href="#419">419</a>         <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.handlerMapper != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="420" href="#420">420</a>             handler = <strong class="jxr_keyword">this</strong>.handlerMapper.lookup(request);
<a class="jxr_linenumber" name="421" href="#421">421</a>         }
<a class="jxr_linenumber" name="422" href="#422">422</a>         <strong class="jxr_keyword">if</strong> (handler != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="423" href="#423">423</a>             handler.handle(request, response, context);
<a class="jxr_linenumber" name="424" href="#424">424</a>         } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="425" href="#425">425</a>             response.setStatusCode(HttpStatus.SC_NOT_IMPLEMENTED);
<a class="jxr_linenumber" name="426" href="#426">426</a>         }
<a class="jxr_linenumber" name="427" href="#427">427</a>     }
<a class="jxr_linenumber" name="428" href="#428">428</a> 
<a class="jxr_linenumber" name="429" href="#429">429</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="430" href="#430">430</a> <em class="jxr_javadoccomment">     * Adaptor class to transition from HttpRequestHandlerResolver to HttpRequestHandlerMapper.</em>
<a class="jxr_linenumber" name="431" href="#431">431</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="432" href="#432">432</a>     @Deprecated
<a class="jxr_linenumber" name="433" href="#433">433</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../org/apache/http/protocol/HttpService.html">HttpRequestHandlerResolverAdapter</a> <strong class="jxr_keyword">implements</strong> <a href="../../../../org/apache/http/protocol/HttpRequestHandlerMapper.html">HttpRequestHandlerMapper</a> {
<a class="jxr_linenumber" name="434" href="#434">434</a> 
<a class="jxr_linenumber" name="435" href="#435">435</a>         <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/protocol/HttpRequestHandlerResolver.html">HttpRequestHandlerResolver</a> resolver;
<a class="jxr_linenumber" name="436" href="#436">436</a> 
<a class="jxr_linenumber" name="437" href="#437">437</a>         <strong class="jxr_keyword">public</strong> <a href="../../../../org/apache/http/protocol/HttpService.html">HttpRequestHandlerResolverAdapter</a>(<strong class="jxr_keyword">final</strong> <a href="../../../../org/apache/http/protocol/HttpRequestHandlerResolver.html">HttpRequestHandlerResolver</a> resolver) {
<a class="jxr_linenumber" name="438" href="#438">438</a>             <strong class="jxr_keyword">this</strong>.resolver = resolver;
<a class="jxr_linenumber" name="439" href="#439">439</a>         }
<a class="jxr_linenumber" name="440" href="#440">440</a> 
<a class="jxr_linenumber" name="441" href="#441">441</a>         <strong class="jxr_keyword">public</strong> <a href="../../../../org/apache/http/protocol/HttpRequestHandler.html">HttpRequestHandler</a> lookup(<a href="../../../../org/apache/http/HttpRequest.html">HttpRequest</a> request) {
<a class="jxr_linenumber" name="442" href="#442">442</a>             <strong class="jxr_keyword">return</strong> resolver.lookup(request.getRequestLine().getUri());
<a class="jxr_linenumber" name="443" href="#443">443</a>         }
<a class="jxr_linenumber" name="444" href="#444">444</a> 
<a class="jxr_linenumber" name="445" href="#445">445</a>     }
<a class="jxr_linenumber" name="446" href="#446">446</a> 
<a class="jxr_linenumber" name="447" href="#447">447</a> }
</pre>
<hr/><div id="footer">This page was automatically generated by <a href="http://maven.apache.org/">Maven</a></div></body>
</html>

